/* 
 *   author: santiago garcia jimenez
 *
 *   EMAIL: animanegra@gmail.com
 *
 *   public under GPL3 license.
 *
 *
 *   Copyright (C) 2008 santiago garcia jimenez
 *
 *   This program is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation, either version 3 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */
process muestra_bloque(int numero)
begin

	z=20;

	if(numero==0)

		x=155;
		y=20;
	end

	if(numero == 1)
	
		x=165;
		y=20;
	end

	if(numero == 2)

		x=165;
		y=10;
	
	end

	if(numero == 3)

		x=155;
		y=10;

	end

	size=50;

	loop

		if(graph != bloque[(siguiente[numero])][0])

			graph=bloque[(siguiente[numero])][0];

		end

		frame;

	end

end

function mata_procesos()
begin

	while(exists(type nave))

		signal(type nave,s_kill);

	end

	while(exists(type disparo))

		signal(type disparo,s_kill);

	end

	while(exists(type muestra_bloque))

		signal(type muestra_bloque,s_kill);

	end
	
	while(exists(type bloque))

		signal(type bloque,s_kill);

	end

	while(exists(type bloque_desaparece))

		signal(type bloque_desaparece,s_kill);

	end

	while(exists(type proceso_fondo))

		signal(type proceso_fondo,s_kill);

	end

	while(exists(type proceso_fondo_nivel))

		signal(type proceso_fondo_nivel,s_kill);

	end

	while(exists(type linea))

		signal(type linea,s_kill);

	end

	delete_text(ALL_TEXT);
end

process proceso_fondo(graph,x,y)
begin

	z=99;

	loop

		frame;

	end

end

process proceso_fondo_nivel(graph,x,y)
begin

	z=102;

	loop

		frame;

	end

end

process proceso_pause()
private

	int pause_tecla;

begin

	graph=letras_menu[4];
	x=160;
	y=120;

	pause_on=1;
	pause_tecla=0;

	if(key(_enter))

		pause_tecla=1;

	end

	size=0;

	loop

		if((pause_tecla==0) and (key(_enter)))

			break;

		end

		if(!key(_enter))

			pause_tecla=0;

		end

		if(size < 50)

			size=size+5;

		end

		frame;

	end

	while(key(_enter))

		frame;

	end

	pause_on=0;

end

process nivel()
private
	int puntos_anterior;
	int texto_puntos;
	int texto_nivel;
begin

	carga(nivel);

	proceso_fondo(fondo_base[nivel%total_pantallas],160,120);
	proceso_fondo_nivel(fondo[nivel%total_pantallas],160,120);

	velocidad=nivel+1;

	play_song(musica_block[nivel%total_pantallas],-1);

	siguiente[0]=rand(0,3);
	siguiente[1]=rand(0,3);
	siguiente[2]=rand(0,3);
	siguiente[3]=rand(0,3);

	bloque(0);
	bloque(1);
	bloque(2);
	bloque(3);

	muestra_bloque(0);
	muestra_bloque(1);
	muestra_bloque(2);
	muestra_bloque(3);

	linea(0);

	nave();

	puntos_anterior=puntuacion;

	pasa_nivel=0;

	pause_on=2;

	loop

		texto_puntos=write(0,70,10,0,puntuacion);
		texto_nivel=write(0,265,10,0,nivel);

		if(puntuacion - puntos_anterior > 50)


			nivel=nivel+1;

			put_screen(0,fondo_interlevel);

			mata_procesos();

			stop_song();

			play_song(musica_menu,-1);	

			while(!key(_enter))

				frame;

			end

			while(key(_enter))

				frame;

			end

			put_screen(0,fondo_interlevel);

			pasa_nivel=1;

			stop_song();

			break;

		end

		if(jugador==-1)

			if(key(_enter))

				mata_procesos();

				stop_song();

				while(key(_enter))

					frame;

				end

				pantalla_seleccion=1;

				break;

			end

		end

		if(key(_enter) and pause_on==0)

			proceso_pause();

		end

		if(!key(_enter) and pause_on==2)

			pause_on=0;

		end

		frame;

		delete_text(texto_puntos);
		delete_text(texto_nivel);

	end

end
