/* 
 *   author: santiago garcia jimenez
 *
 *   EMAIL: animanegra@gmail.com
 *
 *   public under GPL3 license.
 *
 *
 *   Copyright (C) 2008 santiago garcia jimenez
 *
 *   This program is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation, either version 3 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */
global
	TAMANO_BLOQUE=21;
	int desapareciendo;
	int contador;
	int primero;
local

	int desaparece;
	int cayendo;
	int eliminar;
	int direccion;
	int comprueba;
	int nopuntos;

process disparo(x,y)
private
	int proceso;
begin

	graph=disparo_grafico;
	z=100;
	y=y+20;

	loop

		y=y+10;

		proceso=collision(type bloque);

		if(proceso != 0)

			if(proceso.cayendo != 1)

				signal(proceso,S_WAKEUP);

				proceso.desaparece=1;
				proceso.nopuntos=1;

				break;

			end

		end

		if(y > 240)

			break;

		end

		frame;

	end

end

process nave()
private
	int salir;
	int pulsada;
begin

	salir=rand(0,2880);

	while((salir>0) and (jugador!=-1))

		salir=salir-1;

		frame;

		while(pause_on==1)

			frame;

		end

	end



	graph=nave_grafico;
	salir=rand(0,1);
	y=50;
	x=320*salir;
	z=100;

	if(botones[3] or botones[4])

		pulsada=1;

	else

		pulsada=0;

	end

	loop

		if(botones[3] and botones[4] and pulsada==0)

			if(jugador != -1)

				disparo(x,y);

			end

		end

		if(salir==0)

			x=x+(nivel+1);

		else

			x=x-(nivel+1);

		end

		if(salir==0)

			if(x > 320)

				break;

			end

		else

			if(x < 0)

				break;

			end

		end

		if(botones[3] or botones[4])

			pulsada=1;

		else

			pulsada=0;

		end

		frame;

		while(pause_on==1)

			frame;

		end

	end

end

process linea(int numero)
private

	int i;
	int ii;
	int xant;

	int proceso;
	int ultimo_proceso;

begin

	x=14;
	y=130;

	direccion=+1;

	if(numero==0)

		z=2;

		graph=linea[0];

		linea(1);
		linea(2);
		
	end

	if(numero==1)

		z=3;

		graph=linea[1];

		alpha=100;

	end

	if(numero==2)

		z=4;

		graph=linea[2];

		alpha=50;

	end

	ii=0;

	loop

		ii=ii+1;

		if(ii < 11)

			alpha=alpha-10;

		else

			alpha=alpha+10;

			if(ii == 20)

				ii = 0;

			end

		end

		if(jugador == -1)


			break;

		end

		if(numero==0)

			xant=x;

			while(direccion*(x-xant) < musica_vel[nivel])

				x=x+direccion;

				if(collision(type proceso_fondo))

					puntuacion=puntuacion+contador;

					if(contador > 4)

						 puntuacion=puntuacion+contador;

					end

					if(contador > 8)

						puntuacion=puntuacion+contador;

					end

					if(contador > 10)

						puntuacion=puntuacion+contador;

					end

					contador=0;

					x=x-direccion;

					direccion=-direccion;

				end

			end

		end

		if(numero == 1)

			x=father.x-(3*father.direccion);

		end

		if(numero == 2)

			x=father.x-(6*father.direccion);

		end

		frame;

		while(pause_on==1)

			frame;

		end

	end

end
process bloque_desaparece(x,y,graph,sinpuntos)
begin

	if(sinpuntos == 0)

		contador=contador+1;

	end

	loop

		size=size+1;

		alpha=alpha-10;

		if(alpha < 19)

			break;

		end

		frame;

		while(pause_on==1)

			frame;

		end

	end

end

process bloque(int numero)
private
	int aleatorio;
	int pulsada;
	int pulsada_direccion;
	int i;
	int ii;
	int yant;
	int colision_fondo;
	int colision_bloque;
	int proceso;
	int velocidad_bajada;
	int misprocesos[3];

begin

	i = 0;

	if(jugador == -1)

		return;

	end

	procesos[numero]=id;

	z=101;

	if(numero==3)

		x=160-(TAMANO_BLOQUE/2)-1;
		y=61-TAMANO_BLOQUE;

	end

	if(numero==0)

		x=160-(TAMANO_BLOQUE/2)-1;
		y=61;

	end
	
	if(numero==2)

		x=160+(TAMANO_BLOQUE/2);
		y=61-TAMANO_BLOQUE;

	end

	if(numero==1)

		x=160+(TAMANO_BLOQUE/2);
		y=61;

	end

	graph=bloque[siguiente[numero]][0];

	siguiente[numero]=rand(0,3);

	if(collision(type bloque))

		if(jugador != -1)

			signal(0,S_WAKEUP);

			jugador=-1;

			play_wav(ooo_sonido,0);

			signal(type bloque,S_WAKEUP);

		end

		graph=bloque[4][0];

		loop

			frame;

		end

	end

	desaparece=0;
	cayendo=1;
	pulsada=0;
	primero=0;

	while(!exists(procesos[1]) or !exists(procesos[2]) or !exists(procesos[3]) or !exists(procesos[0]))

		if(jugador==-1)

			graph=bloque[4][0];

			loop

				frame;

			end


		end

		frame;

		while(pause_on==1)

			frame;

		end	

	end

	if(primero == 0)

		primero=1;

		frame;

		while(pause_on==1)

			frame;

		end

	end

	if((botones[3]) or (botones[4]) or (botones[5]))

		pulsada=1;

	else

		pulsada=0;

	end

	loop

		if(jugador==-1)

			graph=bloque[4][0];

			loop

				frame;

			end

		end

		if(exists(procesos[1]) and exists(procesos[2]) and exists(procesos[3]) and exists(procesos[0]))

			if((procesos[0].cayendo==1) and (procesos[1].cayendo==1) and (procesos[2].cayendo==1) and (procesos[3].cayendo==1))

				if(pulsada==0)

					if(botones[3])

						if(numero==0)

							ii=graph;
							graph=procesos[3].graph;
							procesos[3].graph=procesos[2].graph;
							procesos[2].graph=procesos[1].graph;
							procesos[1].graph=ii;

						end

					end
	
					if(botones[4])
	
						if(numero==0)
	
							ii=graph;
							graph=procesos[1].graph;
							procesos[1].graph=procesos[2].graph;
							procesos[2].graph=procesos[3].graph;
							procesos[3].graph=ii;
							
	
						end
	
					end

				end
	
			end

			if((procesos[0].cayendo==1) and (procesos[1].cayendo==1) 
				and (procesos[2].cayendo==1) and (procesos[3].cayendo==1))

				if((botones[1]) and (pulsada_direccion==0))

					if(numero==0)

						x=x-TAMANO_BLOQUE;

						colision_bloque=0;

						collision(type nave);

						while(proceso=collision(type bloque))

							if(proceso==0)

								break;
	
							end

							if(proceso.cayendo!=1)

								colision_bloque=1;

								break;

							end

						end

						if((colision_bloque==0) and (collision(type proceso_fondo) == 0))

							y=y-TAMANO_BLOQUE;

							colision_bloque=0;

							collision(type nave);

							while(proceso=collision(type bloque))

								if(proceso==0)

									break;

								end

								if(proceso.cayendo!=1)

									colision_bloque=1;

									break;

								end

							end					

							if((colision_bloque==0) and (collision(type proceso_fondo) == 0))

								procesos[1].x=procesos[1].x-TAMANO_BLOQUE;
								procesos[2].x=procesos[2].x-TAMANO_BLOQUE;
								procesos[3].x=procesos[3].x-TAMANO_BLOQUE;
										
							else

								x=x+TAMANO_BLOQUE;

							end

							y=y+TAMANO_BLOQUE;

						else

							x=x+TAMANO_BLOQUE;

						end

					end

				end

				if(botones[2] and (pulsada_direccion==0))

					if(numero==1)

						x=x+TAMANO_BLOQUE;

						colision_bloque=0;

						collision(type nave);

						while(proceso=collision(type bloque))

							if(proceso==0)

								break;

							end

							if(proceso.cayendo!=1)

								colision_bloque=1;

								break;

							end

						end

						if((colision_bloque==0) and (collision(type proceso_fondo) == 0))

							y=y-TAMANO_BLOQUE;

							colision_bloque=0;

							while(proceso=collision(type bloque))

								if(proceso==0)

									break;

								end

								if(proceso.cayendo!=1)

									colision_bloque=1;

									break;

								end

							end

							if((colision_bloque==0) and (collision(type proceso_fondo) == 0))

								procesos[0].x=procesos[0].x+TAMANO_BLOQUE;
								procesos[2].x=procesos[2].x+TAMANO_BLOQUE;
								procesos[3].x=procesos[3].x+TAMANO_BLOQUE;
								
							else

								x=x-TAMANO_BLOQUE;

							end

							y=y+TAMANO_BLOQUE;

						else

							x=x-TAMANO_BLOQUE;

						end

					end

				end

			end

		end

		if((botones[5]) and (pulsada == 0))

			if((numero==0) or (numero==1))

				proceso=0;

				while(proceso==0)

					proceso=collision(type bloque);
					proceso=proceso+collision(type proceso_fondo);

					while(proceso == 0)

						proceso=collision(type bloque);
						proceso=proceso+collision(type proceso_fondo);

						y=y+1;
	
					end

					y=y-(nivel+3);

					if(numero==0)

						procesos[3].y=y-TAMANO_BLOQUE;
						procesos[3].x=x;

						procesos[3].cayendo=0;

					else

						procesos[2].y=y-TAMANO_BLOQUE-1;
						procesos[2].x=x;

						procesos[2].cayendo=0;

					end

				end

			end

			cayendo=0;

		end

		colision_fondo=0;
		colision_bloque=0;

		if(botones[0])

			velocidad_bajada=velocidad*3;

		else

			velocidad_bajada=velocidad;

		end

		yant=y;

		while(y < yant+velocidad_bajada)

			y=y+1;

			if(collision(type proceso_fondo))

				colision_fondo=1;

				break;

			end

			while(proceso=collision(type bloque))

				if(proceso==0)

					break;

				end

				if(proceso.cayendo!=1)

					colision_bloque=1;
	
					break;

				end

			end
		
			if(proceso != 0)

				if((proceso.desaparece != 1) and (proceso.cayendo!=1))

					break;

				end			

			end

		end

		if(colision_fondo == 1)

			y=y-1;

			break;

		end

		if(colision_bloque == 1)

			y=y-1;

			desaparece=2;

		end

		if(desaparece!=0)

			break;

		end




		if((botones[3]) or (botones[4]) or (botones[5]))

			pulsada=1;

		else

			pulsada=0;

		end

		if(((botones[1]) or (botones[2])) and (pulsada_direccion < 2))

			pulsada_direccion=pulsada_direccion+1;

		else

			pulsada_direccion=0;

		end


		frame;

		while(pause_on==1)

			frame;

		end

	end

	cayendo=0;

	while((procesos[0].cayendo!=0) or (procesos[1].cayendo!=0) or (procesos[2].cayendo!=0) or (procesos[3].cayendo!=0))

		frame;

		while(pause_on==1)

			frame;

		end

	end

	x=x+TAMANO_BLOQUE;

	collision(type nave);

	misprocesos[1]=collision(type bloque);

	y=y+TAMANO_BLOQUE;

	collision(type nave);

	misprocesos[2]=collision(type bloque);

	while((misprocesos[2]==misprocesos[1]) and (misprocesos[2]!=0))

		misprocesos[2]=collision(type bloque);

	end

	x=x-TAMANO_BLOQUE;

	collision(type nave);

	misprocesos[3]=collision(type bloque);

	while(((misprocesos[2]==misprocesos[3]) or (misprocesos[1]==misprocesos[3])) and (misprocesos[3]!=0))

		misprocesos[3]=collision(type bloque);

	end

	if((misprocesos[1]!=0) and (misprocesos[2]!=0) and (misprocesos[3]!=0))

		if((graph==misprocesos[1].graph) and (graph==misprocesos[2].graph) and (graph==misprocesos[3].graph))
		
			if((misprocesos[1].cayendo==0) and (misprocesos[2].cayendo==0) and (misprocesos[3].cayendo==0))

					eliminar=1;
					misprocesos[1].eliminar=1;
					misprocesos[2].eliminar=1;
					misprocesos[3].eliminar=1;

					signal(misprocesos[1],S_WAKEUP);
					signal(misprocesos[2],S_WAKEUP);
					signal(misprocesos[3],S_WAKEUP);
			end

		end

	end

	x=x-TAMANO_BLOQUE;

	collision(type nave);

	misprocesos[2]=collision(type bloque);

	while((misprocesos[2]==misprocesos[3])  and (misprocesos[2]!=0))

		misprocesos[2]=collision(type bloque);

	end

	y=y-TAMANO_BLOQUE;

	collision(type nave);
	
	misprocesos[1]=collision(type bloque);

	while(((misprocesos[2]==misprocesos[1]) or (misprocesos[1]==misprocesos[3])) and (misprocesos[1]!=0))

		misprocesos[1]=collision(type bloque);

	end

	if((misprocesos[1]!=0) and (misprocesos[2]!=0) and (misprocesos[3]!=0))

		if((graph==misprocesos[1].graph) and (graph==misprocesos[2].graph) and (graph==misprocesos[3].graph))

		if((misprocesos[1].cayendo==0) and (misprocesos[2].cayendo==0) and (misprocesos[3].cayendo==0))

			eliminar=1;
			misprocesos[1].eliminar=1;
			misprocesos[2].eliminar=1;
			misprocesos[3].eliminar=1;
	
			signal(misprocesos[1],S_WAKEUP);
			signal(misprocesos[2],S_WAKEUP);
			signal(misprocesos[3],S_WAKEUP);

		end

		end

	end

	y=y-TAMANO_BLOQUE;

	collision(type nave);

	misprocesos[2]=collision(type bloque);

	while((misprocesos[2]==misprocesos[1])  and (misprocesos[2]!=0))

		misprocesos[2]=collision(type bloque);

	end

	x=x+TAMANO_BLOQUE;

	collision(type nave);

	misprocesos[3]=collision(type bloque);

	while(((misprocesos[2]==misprocesos[3]) or (misprocesos[1]==misprocesos[3])) and (misprocesos[3]!=0) )

		misprocesos[3]=collision(type bloque);

	end

	if((misprocesos[1]!=0) and (misprocesos[2]!=0) and (misprocesos[3]!=0))

		if((graph==misprocesos[1].graph) and (graph==misprocesos[2].graph) and (graph==misprocesos[3].graph))

		if((misprocesos[1].cayendo==0) and (misprocesos[2].cayendo==0) and (misprocesos[3].cayendo==0))

			eliminar=1;
			misprocesos[1].eliminar=1;
			misprocesos[2].eliminar=1;
			misprocesos[3].eliminar=1;
	
			signal(misprocesos[1],S_WAKEUP);
			signal(misprocesos[2],S_WAKEUP);
			signal(misprocesos[3],S_WAKEUP);

		end

		end

	end

	x=x+TAMANO_BLOQUE;

	collision(type nave);


	misprocesos[2]=collision(type bloque);

	while((misprocesos[3]==misprocesos[2])  and (misprocesos[2]!=0))

		misprocesos[2]=collision(type bloque);

	end

	y=y+TAMANO_BLOQUE;

	collision(type nave);

	misprocesos[1]=collision(type bloque);

	while(((misprocesos[1]==misprocesos[2]) or (misprocesos[3]==misprocesos[1])) and (misprocesos[1]!=0))

		misprocesos[1]=collision(type bloque);

	end

	x=x-TAMANO_BLOQUE;

	if((misprocesos[1]!=0) and (misprocesos[2]!=0) and (misprocesos[3]!=0))

		if((graph==misprocesos[1].graph) and (graph==misprocesos[2].graph) and (graph==misprocesos[3].graph))

		if((misprocesos[1].cayendo==0) and (misprocesos[2].cayendo==0) and (misprocesos[3].cayendo==0))

			eliminar=1;
			misprocesos[1].eliminar=1;
			misprocesos[2].eliminar=1;
			misprocesos[3].eliminar=1;
	
			signal(misprocesos[1],S_WAKEUP);
			signal(misprocesos[2],S_WAKEUP);
			signal(misprocesos[3],S_WAKEUP);

		end

		end

	end

	frame;

	while(pause_on==1)

		frame;

	end

	i=0;

	while(i<4)

		if(exists(procesos[i]))

			if(procesos[i].cayendo!=0)

				break;

			end

		end

		i = i +1;

	end

	if(i == 4)

		bloque(0);
		bloque(1);
		bloque(2);
		bloque(3);

	end

	comprueba=1;

	loop

		if(desapareciendo > 0)

			frame;

			while(pause_on==1)

				frame;

			end

		end

		if(desaparece == 1)

			desapareciendo=desapareciendo+1;

			play_wav(yupi_sonido,0);
	
			bloque_desaparece(x,y,graph,nopuntos);

			collision(type nave);

			y=y-TAMANO_BLOQUE;

			misprocesos[1]=collision(type bloque);

			if(misprocesos[1] != 0)

				signal(misprocesos[1],S_WAKEUP);

				misprocesos[1].comprueba=1;

			end

			y=y-TAMANO_BLOQUE;

			desapareciendo=desapareciendo-1;

			return;

		end



		if(comprueba > 0)

			y=y-TAMANO_BLOQUE;

			collision(type nave);

			misprocesos[1]=collision(type bloque);

			if(misprocesos[1] != 0)
				
				signal(misprocesos[1],S_WAKEUP);

				misprocesos[1].comprueba=1;

			end

			y=y+TAMANO_BLOQUE;

			collision(type nave);

			i=0;

			while((0==collision(type bloque)) and (0==collision(type proceso_fondo)))

				y=y+1;

				i=i+1;
	
			end

			y=y-1;

			if(i > 1)

				x=x+TAMANO_BLOQUE;

				collision(type nave);

				misprocesos[1]=collision(type bloque);

				y=y+TAMANO_BLOQUE;

				collision(type nave);

				misprocesos[2]=collision(type bloque);

				while((misprocesos[2]==misprocesos[1]) and (misprocesos[2]!=0))

					misprocesos[2]=collision(type bloque);

				end

				x=x-TAMANO_BLOQUE;

				collision(type nave);


				misprocesos[3]=collision(type bloque);

				while(((misprocesos[2]==misprocesos[3]) or (misprocesos[1]==misprocesos[3])) and (misprocesos[3]!=0))

					misprocesos[3]=collision(type bloque);

				end

				if((misprocesos[1]!=0) and (misprocesos[2]!=0) and (misprocesos[3]!=0))

					if((graph==misprocesos[1].graph) and (graph==misprocesos[2].graph) and (graph==misprocesos[3].graph))
		
					if((misprocesos[1].cayendo==0) and (misprocesos[2].cayendo==0) and (misprocesos[3].cayendo==0))

						eliminar=1;
						misprocesos[1].eliminar=1;
						misprocesos[2].eliminar=1;
						misprocesos[3].eliminar=1;
			
						signal(misprocesos[1],S_WAKEUP);
						signal(misprocesos[2],S_WAKEUP);
						signal(misprocesos[3],S_WAKEUP);

					end

					end

				end

				x=x-TAMANO_BLOQUE;

				collision(type nave);

				misprocesos[2]=collision(type bloque);

				while((misprocesos[2]==misprocesos[3])  and (misprocesos[2]!=0))

					misprocesos[2]=collision(type bloque);

				end

				y=y-TAMANO_BLOQUE;

				collision(type nave);

				misprocesos[1]=collision(type bloque);

				while(((misprocesos[2]==misprocesos[1]) or (misprocesos[1]==misprocesos[3])) and (misprocesos[1]!=0))

					misprocesos[1]=collision(type bloque);

				end

				if((misprocesos[1]!=0) and (misprocesos[2]!=0) and (misprocesos[3]!=0))

					if((graph==misprocesos[1].graph) and (graph==misprocesos[2].graph) and (graph==misprocesos[3].graph))

					if((misprocesos[1].cayendo==0) and (misprocesos[2].cayendo==0) and (misprocesos[3].cayendo==0))

						eliminar=1;
						misprocesos[1].eliminar=1;
						misprocesos[2].eliminar=1;
						misprocesos[3].eliminar=1;
			
						signal(misprocesos[1],S_WAKEUP);
						signal(misprocesos[2],S_WAKEUP);
						signal(misprocesos[3],S_WAKEUP);

					end

					end

				end
			
				y=y-TAMANO_BLOQUE;

				collision(type nave);

				misprocesos[2]=collision(type bloque);

				while((misprocesos[2]==misprocesos[1])  and (misprocesos[2]!=0))

					misprocesos[2]=collision(type bloque);

				end

				x=x+TAMANO_BLOQUE;

				collision(type nave);

				misprocesos[3]=collision(type bloque);

				while(((misprocesos[2]==misprocesos[3]) or (misprocesos[1]==misprocesos[3])) and (misprocesos[3]!=0) )

					misprocesos[3]=collision(type bloque);

				end

				if((misprocesos[1]!=0) and (misprocesos[2]!=0) and (misprocesos[3]!=0))

					if((graph==misprocesos[1].graph) and (graph==misprocesos[2].graph) and (graph==misprocesos[3].graph))

					if((misprocesos[1].cayendo==0) and (misprocesos[2].cayendo==0) and (misprocesos[3].cayendo==0))

						eliminar=1;
						misprocesos[1].eliminar=1;
						misprocesos[2].eliminar=1;
						misprocesos[3].eliminar=1;
			
						signal(misprocesos[1],S_WAKEUP);
						signal(misprocesos[2],S_WAKEUP);
						signal(misprocesos[3],S_WAKEUP);

					end

					end

				end

				x=x+TAMANO_BLOQUE;

				collision(type nave);

				misprocesos[2]=collision(type bloque);

				while((misprocesos[3]==misprocesos[2])  and (misprocesos[2]!=0))

					misprocesos[2]=collision(type bloque);

				end

				y=y+TAMANO_BLOQUE;

				collision(type nave);

				misprocesos[1]=collision(type bloque);

				while(((misprocesos[1]==misprocesos[2]) or (misprocesos[3]==misprocesos[1])) and (misprocesos[1]!=0))

					misprocesos[1]=collision(type bloque);

				end

				x=x-TAMANO_BLOQUE;

				collision(type nave);

				if((misprocesos[1]!=0) and (misprocesos[2]!=0) and (misprocesos[3]!=0))

					if((graph==misprocesos[1].graph) and (graph==misprocesos[2].graph) and (graph==misprocesos[3].graph))

					if((misprocesos[1].cayendo==0) and (misprocesos[2].cayendo==0) and (misprocesos[3].cayendo==0))

						eliminar=1;
						misprocesos[1].eliminar=1;
						misprocesos[2].eliminar=1;
						misprocesos[3].eliminar=1;
						
						signal(misprocesos[1],S_WAKEUP);
						signal(misprocesos[2],S_WAKEUP);
						signal(misprocesos[3],S_WAKEUP);

					end

					end

				end

			end

	
		end


		if(jugador == -1)


			graph=bloque[4][0];

		end

		collision(type bloque);
		
		if(((collision(type linea)) or (collision(type bloque_desaparece))) and eliminar==1)

			desaparece=1;

		end

		comprueba=0;

		if(eliminar == 0)

			signal(id,S_FREEZE);

		end

		frame;

		while(pause_on==1)

			frame;

		end

	end

end
