/* 
 *   author: santiago garcia jimenez
 *
 *   EMAIL: animanegra@gmail.com
 *
 *   public under GPL3 license.
 *
 *
 *   Copyright (C) 2008 santiago garcia jimenez
 *
 *   This program is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation, either version 3 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */
global
	int fondo[5];

	int bloque[4][2];

	int jugador;

	int fondo_base[5];

	int nivel;

	int pantalla_seleccion;

	int bloque_sonido[4];
	int yupi_sonido;
	int ooo_sonido;

	int musica_block[5];
	int musica_vel[5];

	int velocidad;

	int botones[5];

	int puntuacion;

	int pasa_nivel;

	int procesos[4];

	int linea[3];

	int colision;

	int moviendo_bloque;

	int musica_menu;

	int fondo_menu;

	int total_pantallas;

	int fondo_interlevel;

	int pantallas_ayuda[15];

	int pantallas_creditos[5];

	int letras_menu[4];

	int seleccion;

	int pause_on;

	int siguiente[4];

	int nave_grafico;

	int disparo_grafico;

function prepara_pantalla()
begin


end
function descarga()
private
	int i;
begin

	unload_map(0,nave_grafico);

	unload_map(0,disparo_grafico);

	i=0;

	while(i < 1)

		unload_map(0,fondo[i]);

		i=i+1;

	end

	i=0;

	while(i < 1)

		unload_map(0,fondo_base[i]);

		i=i+1;

	end

	unload_map(0,fondo_menu);

	unload_map(0,fondo_interlevel);

	unload_map(0,bloque[0][0]);
	unload_map(0,bloque[1][0]);
	unload_map(0,bloque[2][0]);
	unload_map(0,bloque[3][0]);
	unload_map(0,bloque[4][0]);

	i=0;

	while(i < 1)

		unload_wav(bloque_sonido[i]);

		i=i+1;

	end

	unload_map(0,linea[0]);
	unload_map(0,linea[1]);
	unload_map(0,linea[2]);

	unload_map(0,colision);

        unload_wav(yupi_sonido);

        unload_wav(ooo_sonido);

	unload_song(musica_block);

	i=0;

	while(i < 1)

		unload_song(musica_block[i]);

		i=i+1;

	end

end

function carga(int i)
begin

	total_pantallas=5;

	if(i==-1)

		set_mode(320,240,16);
		//set_fps(24,0);

		bloque[0][0]=load_png("./images/block/blockblue.png");
		bloque[1][0]=load_png("./images/block/blockgreen.png");
		bloque[2][0]=load_png("./images/block/blockred.png");
		bloque[3][0]=load_png("./images/block/blockyellow.png");
		bloque[4][0]=load_png("./images/block/blockblack.png");

		linea[0]=load_png("./images/line/line1.png");
		linea[1]=load_png("./images/line/line2.png");
		linea[2]=load_png("./images/line/line3.png");

	        yupi_sonido=load_wav("./sounds/block/yupi.wav");
	        ooo_sonido=load_wav("./sounds/block/oou.wav");

		musica_menu=load_song("./music/begining.ogg");

		fondo_menu=load_png("./images/back/titulo.png");

		fondo_interlevel=load_png("./images/back/titulo_interlevel.png");

		pantallas_ayuda[0]=load_png("./images/back/ayuda1.png");
		pantallas_ayuda[1]=load_png("./images/back/ayuda2.png");
		pantallas_ayuda[2]=load_png("./images/back/ayuda3.png");
		pantallas_ayuda[3]=load_png("./images/back/ayuda4.png");
		pantallas_ayuda[4]=load_png("./images/back/ayuda5.png");
		pantallas_ayuda[5]=load_png("./images/back/ayuda6.png");
		pantallas_ayuda[6]=load_png("./images/back/ayuda7.png");
		pantallas_ayuda[7]=load_png("./images/back/ayuda8.png");
		pantallas_ayuda[8]=load_png("./images/back/ayuda9.png");
		pantallas_ayuda[9]=load_png("./images/back/ayuda10.png");
		pantallas_ayuda[10]=load_png("./images/back/ayuda11.png");
		pantallas_ayuda[11]=load_png("./images/back/ayuda12.png");
		pantallas_ayuda[12]=load_png("./images/back/ayuda13.png");
		pantallas_ayuda[13]=load_png("./images/back/ayuda14.png");
		pantallas_ayuda[14]=load_png("./images/back/ayuda15.png");

		pantallas_creditos[0]=load_png("./images/creditos/creditos1.png");
                pantallas_creditos[1]=load_png("./images/creditos/creditos2.png");
                pantallas_creditos[2]=load_png("./images/creditos/creditos3.png");
                pantallas_creditos[3]=load_png("./images/creditos/creditos4.png");
                pantallas_creditos[4]=load_png("./images/creditos/creditos5.png");

		letras_menu[0]=load_png("./images/letras/nuevojuego.png");
		letras_menu[1]=load_png("./images/letras/ayuda.png");
		letras_menu[2]=load_png("./images/letras/creditos.png");
		letras_menu[3]=load_png("./images/letras/salir.png");
		letras_menu[4]=load_png("./images/letras/pause.png");

		nave_grafico=load_png("./images/ship/ship.png");
		disparo_grafico=load_png("./images/ship/shoot.png");

	end

	if(i==0)

		fondo[0]=load_png("./images/back/backlevel1.png");

		fondo_base[0]=load_png("./images/back/backbase.png");

		musica_block[0]=load_song("./music/electromaniac.ogg");
		musica_vel[0]=3;

	end

	if(i==1)

		fondo[1]=load_png("./images/back/backlevel2.png");

		fondo_base[1]=load_png("./images/back/backbase.png");

		musica_block[1]=load_song("./music/pretyravegirliamxray.ogg");
		musica_vel[1]=7;


	end

	if(i==2)

		fondo[2]=load_png("./images/back/backlevel3.png");

		fondo_base[2]=load_png("./images/back/backbase.png");

		musica_block[2]=load_song("./music/river.ogg");
		musica_vel[2]=1;
	

	end

	if(i==3)

		fondo[3]=load_png("./images/back/backlevel4.png");

		fondo_base[3]=load_png("./images/back/backbase.png");

		musica_block[3]=load_song("./music/electricity.ogg");
		musica_vel[3]=5;
	

	end

	if(i==4)

		fondo[4]=load_png("./images/back/backlevel5.png");

		fondo_base[4]=load_png("./images/back/backbase.png");

		musica_block[4]=load_song("./music/tomorrow.ogg");
		musica_vel[4]=2;
	

	end

end

process pulsa_botones()
begin

	loop

		if(key(_down))

			botones[0]=1;

		else

			botones[0]=0;

		end

		if(key(_left))

			botones[1]=1;

		else

			botones[1]=0;

		end
		if(key(_right))

			botones[2]=1;

		else

			botones[2]=0;

		end
		if(key(_control))

			botones[3]=1;

		else

			botones[3]=0;

		end
		if(key(_alt))

			botones[4]=1;

		else

			botones[4]=0;

		end

		if(key(_up))

			botones[5]=1;

		else

			botones[5]=0;

		end

		frame;

	end

end

process creditos()
private
	int i;
begin

	i=0;

	while(i < 5)

		put_screen(0,pantallas_creditos[i]);

		while(key(_enter))

			frame;

		end

		while(!key(_enter))

			frame;

		end

		i = i + 1;

	end

	put_screen(0,fondo_menu);

	while(key(_enter))

		frame;

	end

	pantalla_seleccion=2;

	letras_empezar();

	letras_ayuda();

	letras_creditos();

	letras_salir();

end

process ayuda()
private
	int i;
begin

	i=0;

	while(i < 15)

		put_screen(0,pantallas_ayuda[i]);

		while(key(_enter))

			frame;

		end

		while(!key(_enter))

			frame;

		end

		i = i + 1;

	end

	put_screen(0,fondo_menu);

	while(key(_enter))

		frame;

	end

	pantalla_seleccion=2;

	letras_empezar();

	letras_ayuda();

	letras_creditos();

	letras_salir();

end

process letras_empezar()
private
	int tamano_grande;
	int tamano_pequeno;
	int avance;
begin

	graph=letras_menu[0];

	x=160;
	y=162;

	tamano_grande=100;
	tamano_pequeno=30;

	avance=10;

	size=tamano_pequeno;

	loop

		alpha=(size-30)*3;

		if(seleccion==0)

			size=size+avance;

			if(size > tamano_grande)

				size=size-avance;

			end
		else

			size=size-(avance/2);

			if(size<tamano_pequeno)

				size=size+(avance/2);

			end


		end

		if((pantalla_seleccion!=1) and (pantalla_seleccion != 2))

			break;

		end

		frame;

	end

end

process letras_ayuda()
private
	int tamano_grande;
	int tamano_pequeno;
	int avance;
begin

	graph=letras_menu[1];

	x=160;
	y=162;

	tamano_grande=100;
	tamano_pequeno=30;

	avance=10;

	size=tamano_pequeno;

	loop

		alpha=(size-30)*3;

		if(seleccion==1)

			size=size+avance;

			if(size > tamano_grande)

				size=size-avance;

			end
		else

			size=size-(avance/2);

			if(size<tamano_pequeno)

				size=size+(avance/2);

			end


		end

		if((pantalla_seleccion!=1) and (pantalla_seleccion != 2))

			break;

		end

		frame;

	end

end

process letras_creditos()
private
	int tamano_grande;
	int tamano_pequeno;
	int avance;
begin

	graph=letras_menu[2];

	x=160;
	y=162;

	tamano_grande=100;
	tamano_pequeno=30;

	avance=10;

	size=tamano_pequeno;

	loop

		alpha=(size-30)*3;

		if(seleccion==2)

			size=size+avance;

			if(size > tamano_grande)

				size=size-avance;

			end
		else

			size=size-(avance/2);

			if(size<tamano_pequeno)

				size=size+(avance/2);

			end


		end

		if((pantalla_seleccion!=1) and (pantalla_seleccion != 2))

			break;

		end

		frame;

	end

end

process letras_salir()
private
	int tamano_grande;
	int tamano_pequeno;
	int avance;
begin

	graph=letras_menu[3];

	x=160;
	y=162;

	tamano_grande=100;
	tamano_pequeno=30;

	avance=10;

	size=tamano_pequeno;

	loop

		alpha=(size-30)*3;

		if(seleccion==3)

			size=size+avance;

			if(size > tamano_grande)

				size=size-avance;

			end
		else

			size=size-(avance/2);

			if(size<tamano_pequeno)

				size=size+(avance/2);

			end


		end

		if((pantalla_seleccion!=1) and (pantalla_seleccion != 2))

			break;

		end

		frame;

	end

end
process menu()
private
	int bloque_i;
	int ii;
	int direccion_pulsada;
begin

	carga(-1);

	prepara_pantalla();

	pulsa_botones();

	pantalla_seleccion=1;

	loop

		if(pantalla_seleccion==1)

			put_screen(0,fondo_menu);

			play_song(musica_menu,-1);

			letras_empezar();

			letras_ayuda();

			letras_creditos();

			letras_salir();

			puntuacion=0;
		        nivel=0;
			
			jugador=0;

			pantalla_seleccion=2;

		end

		if(pantalla_seleccion==2)

			if((key(_up)) and (direccion_pulsada==0))

				seleccion=(seleccion-1);

				if(seleccion < 0)

					seleccion=3;

				end

			end

			if((key(_down)) and (direccion_pulsada==0))

				seleccion=(seleccion+1)%4;

			end

			if(key(_enter))

				if(seleccion==0)

					pasa_nivel=1;
	
					pantalla_seleccion=0;

					stop_song();

				end


				if(seleccion==3)

					break;

				end

				if(seleccion==1)

					pantalla_seleccion=3;

					ayuda();

				end

				if(seleccion==2)

					pantalla_seleccion=3;

					creditos();

				end

			end

			if((key(_up)) or (key(_down)))

				direccion_pulsada=1;

			else

				direccion_pulsada=0;

			end

		end

		if(pasa_nivel==1)

			nivel();

		end



		frame;

	end;

	let_me_alone();

end
